// Generated by CoffeeScript 1.6.2
(function() {
  var ApiBase, _ref,
    __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  ApiBase = require('./ApiBase').ApiBase;

  module.exports.ApiBaseHTTP = (function(_super) {
    __extends(ApiBaseHTTP, _super);

    function ApiBaseHTTP() {
      this._request = __bind(this._request, this);
      this._parseResponse = __bind(this._parseResponse, this);
      this._request_options = __bind(this._request_options, this);
      this.put = __bind(this.put, this);
      this.post = __bind(this.post, this);
      this["delete"] = __bind(this["delete"], this);
      this.get = __bind(this.get, this);
      this._translateUrl = __bind(this._translateUrl, this);
      this.handleOptions = __bind(this.handleOptions, this);      _ref = ApiBaseHTTP.__super__.constructor.apply(this, arguments);
      return _ref;
    }

    ApiBaseHTTP.prototype.handleOptions = function() {
      var host, key, value, _base, _base1, _base10, _base2, _base3, _base4, _base5, _base6, _base7, _base8, _base9, _ref1, _ref10, _ref11, _ref12, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;

      ApiBaseHTTP.__super__.handleOptions.apply(this, arguments);
      if ((_ref1 = (_base = this.options).debug) == null) {
        _base.debug = false;
      }
      if (this.options.url != null) {
        _ref2 = require('url').parse(this.options.url);
        for (key in _ref2) {
          value = _ref2[key];
          if ((_ref3 = (_base1 = this.options)[key]) == null) {
            _base1[key] = value;
          }
        }
      }
      if ((_ref4 = (_base2 = this.options).host) == null) {
        _base2.host = this.options.hostname;
      }
      host = this.options.host.split(':');
      if ((_ref5 = (_base3 = this.options).hostname) == null) {
        _base3.hostname = host[0];
      }
      if ((_ref6 = (_base4 = this.options).port) == null) {
        _base4.port = host[1];
      }
      if ((_ref7 = (_base5 = this.options).username) == null) {
        _base5.username = null;
      }
      if ((_ref8 = (_base6 = this.options).protocol) == null) {
        _base6.protocol = 'http:';
      }
      if ((_ref9 = (_base7 = this.options).port) == null) {
        _base7.port = this.options.protocol === 'https:' ? 443 : 80;
      }
      this.options.port = parseInt(this.options.port);
      if ((_ref10 = (_base8 = this.options).path) == null) {
        _base8.path = '/';
      }
      if ((_ref11 = (_base9 = this.options).pathname) == null) {
        _base9.pathname = this.options.path;
      }
      this.options.host = "" + this.options.hostname + ":" + this.options.port;
      if ((_ref12 = (_base10 = this.options).base_url) == null) {
        _base10.base_url = '';
      }
      return this.debug("ApiBaseHTTP::handleOptions()");
    };

    ApiBaseHTTP.prototype._translateUrl = function(path) {
      return ("" + this.options.path + "/" + this.options.base_url + "/" + path + "?private_token=" + this.options.token).replace(/\/\//, '/');
    };

    ApiBaseHTTP.prototype.get = function(path, fn) {
      var options;

      if (fn == null) {
        fn = null;
      }
      options = {
        path: this._translateUrl(path),
        method: 'GET'
      };
      return this._request(options, fn);
    };

    ApiBaseHTTP.prototype["delete"] = function(path, fn) {
      var options;

      if (fn == null) {
        fn = null;
      }
      options = {
        path: this._translateUrl(path),
        method: "DELETE"
      };
      return this._request(options, fn);
    };

    ApiBaseHTTP.prototype.post = function(path, data, fn) {
      var options;

      if (data == null) {
        data = {};
      }
      if (fn == null) {
        fn = null;
      }
      options = {
        path: this._translateUrl(path),
        method: 'POST',
        data: data
      };
      return this._request(options, fn);
    };

    ApiBaseHTTP.prototype.put = function(path, data, fn) {
      var options;

      if (data == null) {
        data = {};
      }
      if (fn == null) {
        fn = null;
      }
      options = {
        path: this._translateUrl(path),
        method: 'PUT',
        data: data
      };
      return this._request(options, fn);
    };

    ApiBaseHTTP.prototype._request_options = function(options) {
      var _base, _base1, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7;

      if ((_ref1 = options.host) == null) {
        options.host = this.options.hostname;
      }
      if ((_ref2 = options.protocol) == null) {
        options.protocol = this.options.protocol;
      }
      if ((_ref3 = options.port) == null) {
        options.port = this.options.port;
      }
      if ((_ref4 = options.method) == null) {
        options.method = 'GET';
      }
      if ((_ref5 = options.headers) == null) {
        options.headers = {};
      }
      if ((_ref6 = (_base = options.headers).host) == null) {
        _base.host = this.options.hostname;
      }
      if (this.options.username != null) {
        if ((_ref7 = (_base1 = options.header).Authorization) == null) {
          _base1.Authorization = 'Basic ' + new Buffer("" + this.options.username + ":" + this.options.password).toString('base64');
        }
      }
      return options;
    };

    ApiBaseHTTP.prototype._parseResponse = function(buffer, fn) {
      var e, response;

      if (fn == null) {
        fn = null;
      }
      try {
        response = JSON.parse(buffer);
        if (fn) {
          return fn(response);
        }
      } catch (_error) {
        e = _error;
        return console.log(e, buffer);
      }
    };

    ApiBaseHTTP.prototype._request = function(options, fn) {
      var httpClient, post_data, request, _base, _base1, _ref1, _ref2, _ref3,
        _this = this;

      if (fn == null) {
        fn = null;
      }
      this.debug(options.path);
      this._request_options(options);
      if (options.protocol === 'http:') {
        if (this.httpClient == null) {
          this.httpClient = require('http');
        }
        httpClient = this.httpClient;
      } else if (options.protocol === 'https:') {
        if (this.httpClient_ssl == null) {
          this.httpClient_ssl = require('https');
        }
        httpClient = this.httpClient_ssl;
      }
      if (options.data) {
        post_data = require('querystring').stringify(options.data);
        if ((_ref1 = options.headers) == null) {
          options.headers = {};
        }
        if ((_ref2 = (_base = options.headers)['Content-Length']) == null) {
          _base['Content-Length'] = post_data.length;
        }
        if ((_ref3 = (_base1 = options.headers)['Content-Type']) == null) {
          _base1['Content-Type'] = 'application/x-www-form-urlencoded';
        }
      }
      request = httpClient.request(options);
      if (post_data != null) {
        request.write(post_data);
      }
      request.end();
      return request.on('response', function(response) {
        var buffer;

        buffer = '';
        response.on('data', function(chunk) {
          return buffer += chunk;
        });
        return response.on('end', function() {
          return _this._parseResponse(buffer, fn);
        });
      });
    };

    return ApiBaseHTTP;

  })(ApiBase);

}).call(this);
